#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;
#define sz(a) (a).size()

long long getcnt(string s) {
    vector<pair<char, int>> st;
    for (int i = 0; i < sz(s); ) {
        int j = i;
        while (j < sz(s) && s[j] == s[i]) ++j;
        st.push_back({s[i], j - i});
        i = j;
    }
    auto fin = [](int len) -> long long {
        return len * (long long)(len + 1) / 2;
    };
    long long ans = 0;
    for (int i = 0; i < sz(st); ++i) {
        ans += fin(st[i].second);
        if (i > 0 && i < sz(st) - 1 && st[i].first == '1') {
            ans += min(st[i - 1].second, st[i + 1].second);
        }
    }
    return ans;
}

double readTest() {
    int k = inf.readInt();
    auto readAns = [&](InStream &stream) -> double {
        string s = stream.readLine("[01]{0, 1000000000}", "answer");
        if (getcnt(s) != k) return -1;
        return sz(s);
    };
    auto pa = readAns(ouf);
    auto ja = readAns(ans);
    if (ja < 0) {
        quitf(_fail, "jury's solution is broken");
    }
    if (pa < 0) return 0;
    return max(1.0, ja * 5.0 / pa);
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    double ans = 0;
    int t = inf.readInt();
    for (int i = 0; i < t; i++) {
        ans += readTest();
    }
    // printf("%f", ans);
    quitf(_ok, "Ok");
}