#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;
#define sz(a) (a).size()
vector<vector<int>> G;
vector<bool> used;
vector<int> sub;

bool dfs(int v) {
    cerr << v << endl;
    if (used[v]) return false;
    used[v] = true;
    for (auto i : G[v]) {
        if (!dfs(i)) return false;
        sub[v] += sub[i];
    }
    return true;
}

vector<int> getsub(vector<int> p) {
    int n = sz(p);
    sub = vector<int>(n, 1);
    G = vector<vector<int>>(n);
    used = vector<bool>(n);
    int head = -1;
    for (int i = 0; i < n; ++i)
        if (p[i] == 0) head = i;
        else G[p[i] - 1].push_back(i);
    if (head == -1) return {};
    if (!dfs(head)) return {};
    return sub;
}

double readTest() {
    int n = inf.readInt();
    vector<int> sub(n);
    for (auto &i : sub) i = inf.readInt();
    auto readAns = [&](InStream &stream) -> double {
        string s = stream.readLine();
        if (s == "") return -1;
        stringstream ss;
        ss << s;
        vector<int> p;
        int x;
        while (ss >> x) {
            if (x < 0 || x > n) {
                quitf(_wa, "value of parent is incorrect");
            }
            p.push_back(x);
        }
        if (sz(p) != n) quitf(_wa, "Not empty, nor n elements in the output");
        return getsub(p) == sub ? 1 : -1;
    };
    auto pa = readAns(ouf);
    auto ja = readAns(ans);
    //if (ja < 0) {
    //    quitf(_fail, "jury's solution is broken");
    //}
    if (pa < 0) return 0;
    return 1;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    double ans = 0;
    int t = inf.readInt();
    for (int i = 0; i < t; i++) {
        static int testcase = 1;
        cerr << "Test: " << testcase++ << endl;
        ans += readTest();
    }
    //printf("%f", ans);
    quitf(_ok, "Ok");
}